(function($){

// gallery/image switch by button #pe2-switch
var pe2_gallery=false;
/* state of the code: reflect the header part displayed
 * 	nouser - input for user
 * 	albums - show albums
 *  images - show images from album
 */
var pe2_state='albums';
// picasa user name
var pe2_user_name = 'undefined';
// numbering 
var pe2_current=1;
// save the last request to the server for reload button
var pe2_last_request=false;
var pe2_no_request=false;
// cache for server request both albums and images 
var pe2_cache=[];
/*
 * pe2_options has
 * 	waiting   - loading image and text for waiting message
 * 	env_error - error if editor function can not be found
 * 	image     - label for button Image
 * 	gallery   - label for button Gallery
 * 	reload    - label for button Reload
 *
 *	uniqid    - uniq id for gallery
 *
 *	thumb_w   - thumbnail width
 *	thumb_h   - thumbnail height
 *	thumb_crop - exact dimantions for thumbnail
 *
 *  and all options variables:
 *  
 *  'pe2_configured'        => true,
	'pe2_icon'              => 1,
	'pe2_user_name'         => 'undefined',
	
	'pe2_caption'           => 0,
	'pe2_title'             => 1,
	'pe2_link'              => 'thickbox',

	'pe2_img_align'         => 'left',
	'pe2_img_css'           => '',
	'pe2_img_style'         => '',

	'pe2_gal_align'         => 'left',
	'pe2_gal_css'           => '',
	'pe2_gal_style'         => '',

	'pe2_img_sort'          => 0,
	'pe2_img_asc'           => 1,
	
	'pe2_gal_order'         => 0,
 */


$(function($) {
	// convert encoded options
	for ( var i in pe2_options ) {
		if (pe2_options[i]=='0'||pe2_options[i]=='') pe2_options[i]=false;
		else pe2_options[i] = decodeURIComponent(pe2_options[i]);
		
	}
	
	if ($('#pe2-album').hasClass('hidden')) {
		pe2_state='nouser';
	} else {
		pe2_user_name = $('#pe2-user').text();
		pe2_get_albums();
	}
	pe2_set_handlers();
	// the form permanent handler
	$('#pe2-nouser form').submit(pe2_change_user);
});

function pe2_switch_state(state){
	pe2_state = state;
	$('#pe2-'+state).show().siblings('.pe2-header').hide();
	pe2_set_handlers();
}

function pe2_set_handlers() {

	$('.button').unbind();
	
	$('.pe2-reload').click(function(){
		if (pe2_last_request) {
			if (pe2_state != 'albums') $('#pe2-albums').show().siblings('.pe2-header').hide();
			pe2_cache[pe2_serialize(pe2_last_request)] = false;
			pe2_request(pe2_last_request);
		}
		return(false);
	});

	switch (pe2_state) {
		case 'nouser':
			$('#pe2-change-user').click(pe2_change_user);
			$('#pe2-cu-cancel').click(function() {
				pe2_switch_state('albums');
				pe2_get_albums();
				return(false);
			});
			$('#pe2-main').empty();
		break;
		
		case 'albums':
			$('#pe2-user').click(function(){
				$('#pe2-nouser input').val(pe2_user_name);
				pe2_switch_state('nouser');
				return(false);
			});
		break;
		
		case 'images':
			pe2_current=1;
			$('#pe2-switch').click(function() {
				if (pe2_options.pe2_link == 'thickbox' || pe2_options.pe2_link == 'lightbox' || pe2_options.pe2_link == 'highslide') {
					$(this).text((pe2_gallery)?pe2_options.image:pe2_options.gallery);
					pe2_gallery = pe2_gallery?false:true;
					// if image unselect siblings and run click for the first
					if (!pe2_gallery) {
						$('#pe2-main td.selected').removeClass('selected').eq(0).addClass('selected');
						$('#pe2-main td div.numbers').remove();
					} else {
						pe2_current=1;
						$('#pe2-main td.selected').removeClass('selected').click();
					}
				}
				return(false);
			});
			$('#pe2-album-name').click(function(){
				pe2_switch_state('albums');
				pe2_get_albums();
				return(false);
			});
			$('#pe2-insert').click(function(){
				// format and inserting the code into editor
				pe2_add_to_editor();
				return(false);
			});
			
		break;
	}
}

function pe2_change_user() {
	pe2_user_name = $('#pe2-nouser input').val();
	$('#pe2-user').text(pe2_user_name);
	pe2_switch_state('albums');
	pe2_get_albums();
	return(false);
}

function pe2_request(data) {
	
	if (pe2_no_request) return;
	pe2_no_request = true;
	$('.pe2-reload').hide();
	
	pe2_last_request = data;
	var callback = (data.action=='pe2_get_gallery')?pe2_albums_apply:pe2_images_apply;
	
	if (pe2_cache[pe2_serialize(data)]) {
		callback(pe2_cache[pe2_serialize(data)]);
	} else {
		// set progress image
		$('#pe2-message2').html(pe2_options.waiting);	

		data['cache'] = pe2_serialize(data);
		// since 2.8 ajaxurl is always defined in the admin header and points to admin-ajax.php
		jQuery.post(ajaxurl, data, callback,'json');
	}	
}

function pe2_get_albums(){

	pe2_request({
		action: 'pe2_get_gallery',
		user: pe2_user_name
	});
}

function pe2_album_hanler(){

	pe2_request({
		action: 'pe2_get_images',
		guid: $('a',this).attr('href').replace(/^[^#]*#/,'')
	});

	return(false);
}

function pe2_show_reload() {
	pe2_no_request = false;
	$('.pe2-reload').show().text(pe2_options.reload);
}

function pe2_albums_apply(response) {
	
	pe2_show_reload();
	
	if (response.error) {
		$('#pe2-nouser input').val(pe2_user_name);
		pe2_switch_state('nouser');
		$('#pe2-message1').text(response.error);
		return;
	}

	pe2_cache[response.cache] = response;

	$('#pe2-main').html(response.data);
	$('#pe2-message2').text(response.title);
	document.body.scrollTop=0;

	$('#pe2-main td').unbind().click(pe2_album_hanler);
	// state switched before request
}

function pe2_images_apply(response) {
	
	pe2_show_reload();
	
	if (response.error) {
		$('#pe2-message2').text(response.error);
		return;
	}

	pe2_cache[response.cache] = response;

	$('#pe2-main').html(response.data);
	$('#pe2-album-name').text(response.title);
	document.body.scrollTop=0;

	$('#pe2-main td').unbind().click(pe2_image_hanler);
	pe2_switch_state('images');
}
	
function pe2_image_hanler(){
	
	if (!pe2_gallery) $('#pe2-main td').removeClass('selected');
		
	if (pe2_options.pe2_gal_order && pe2_gallery) {
		if ($(this).hasClass('selected')) {
			var current = Number($('div.numbers',this).html());
			$('div.numbers',this).remove();
			// decrement number for rest if >current
			$('#pe2-main td.selected').each(function(){
				var i = Number($('div.numbers',this).html());
				if (i>current) $('div.numbers',this).html(i-1);
			});
			pe2_current--;
		} else {
			$(this).prepend("<div class='numbers'>"+pe2_current+"</div>");
			pe2_current++;
		}
	}
	
	$(this).toggleClass('selected');
	// check selected to show/hide Insert button
	if ($('#pe2-main td.selected').length==0) $('#pe2-insert').addClass('hidden');
	else $('#pe2-insert').removeClass('hidden');
	
	return(false);
}

function pe2_serialize(data) {
	function Dump(d,l) {
	    if (l == null) l = 1;
	    var s = '';
	    if (typeof(d) == "object") {
	        s += typeof(d) + " {\n";
	        for (var k in d) {
	            for (var i=0; i<l; i++) s += "  ";
	            s += k+": " + Dump(d[k],l+1);
	        }
	        for (var i=0; i<l-1; i++) s += "  ";
	        s += "}\n";
	    } else {
	        s += "" + d + "\n";
	    }
	    return s;
	}
	return Dump(data);
}

function pe2_add_to_editor() {

	var images='', img, icaption, ialbum, isrc, ialt, ititle, iorig;
	
	// prepare common image attributes
	var iclass = (pe2_options.pe2_img_css)?'class="'+pe2_options.pe2_img_css+'" ':'';
	var istyle = (pe2_options.pe2_img_style)?'style="'+pe2_options.pe2_img_style+'" ':'';
	
	// create align vars 
	// for caption - align="alignclass" including alignnone also
	// else add alignclass to iclass 
	var ialign = ''; 
	if (pe2_options.pe2_caption) {
		ialign = 'align="align'+pe2_options.pe2_img_align+'" ';
	} else {
		iclass = (iclass) ? iclass.replace(/\"\s$/,' align'+pe2_options.pe2_img_align+'" ') : 'class="align'+pe2_options.pe2_img_align+'" ';
	}
	
	// check thumb setting and define width or height or both
	var idim   = '';  
	if (pe2_options.thumb_crop) {
		idim = 'width="'+pe2_options.thumb_w+'" height="'+pe2_options.thumb_h+'" ';
	} else {
		idim = (pe2_options.thumb_w)?'width="'+pe2_options.thumb_w+'" ':'height="'+pe2_options.thumb_h+'" ';
	}
	var idimc  = (pe2_options.thumb_w)?'width="'+pe2_options.thumb_w+'" ':'';
	
	// link and gallery additions
	var imore='';
	switch (pe2_options.pe2_link) {
		case 'thickbox':
			imore = 'class="thickbox" ';
			if (pe2_gallery) imore += 'rel="'+pe2_options.uniqid+'" ';
			break;
		case 'lightbox': 
			imore = (pe2_gallery)?'rel="lightbox-'+pe2_options.uniqid+'" ':'rel="lightbox" ';
			break;
		case 'highslide':
			imore = (pe2_gallery)?'class="highslide" onclick="return hs.expand(this,{ slideshowGroup: \''+pe2_options.uniqid+'\' })"':
				'class="highslide" onclick="return hs.expand(this)"';
			break;
	}
	var isep=(pe2_gallery)?'':' ';
	
	// selection order
	var order = (pe2_options.pe2_gal_order && pe2_gallery), img_a=[], i_max=0;
	
	$('#pe2-main td.selected').each(function(i){
		icaption = $('span',this).text();
		ialbum   = $('a',this).attr('href');
		isrc     = $('img',this).attr('src');
		iorig    = isrc.replace(/\/s\d+(\/[^\/]+)$/,'$1');
		ialt     = $('img',this).attr('alt');
		ititle   = (pe2_options.pe2_title)?'title="'+icaption+'" ':'title="" ';
		img='<img src="'+isrc+'" alt="'+ialt+'" '+ititle+iclass+istyle+idim+'/>';
		if (pe2_options.pe2_link != 'none') {
			if (pe2_options.pe2_link == 'picasa') iorig = ialbum;
			img = '<a href="'+iorig+'" '+ititle+imore+'>'+img+'</a>';
		}
		if (pe2_options.pe2_caption) {
			// add caption
			img = '[caption id="" '+ialign+idimc+'caption="'+icaption+'"]'+img+'[/caption]';
		}
		if (order) {
			var i = Number($('div.numbers',this).html()); 
			img_a[i] = img;
			if (i_max<i) i_max=i;
		} else {
			images += img + isep;
		}
			
	});
	
	if (pe2_gallery) {
		
		if (order)
			for(var i=1; i<=i_max; i++) {
				images += img_a[i] + isep;
			}
		
		var gattr = ' ', gal_css = pe2_options.pe2_gal_css || '';
		switch (pe2_options.pe2_gal_align) {
			case 'left': 
			case 'right': 
			case 'center': 
				gal_css += ' align'+pe2_options.pe2_gal_align; 
				break
		}
		if (gal_css.substr(0,1)==' ') gal_css = gal_css.substr(1);
		if (gal_css) gattr += 'class="'+gal_css+'" ';
		if (pe2_options.pe2_gal_style) gattr += 'style="'+pe2_options.pe2_gal_style+'" ';
		if (gattr==' ') gattr='';
		images = '[pe2-gallery'+gattr+']\n'+images+'[/pe2-gallery]';
	}
	
	var win = window.dialogArguments || opener || parent || top;
	if (win['send_to_editor']) win.send_to_editor(images);
	else {
		alert(pe2_options.env_error);
		tb_remove();
	}
}

})(jQuery);
